package polyglot.ext.ibex.extension;

import polyglot.ast.*;
import polyglot.ext.jl.ast.JL_c;
import polyglot.ext.ibex.types.*;
import polyglot.types.*;
import polyglot.visit.*;
import polyglot.util.*;
import java.util.*;

/**
 * TODO: Documentation
 */
public class IbexReturnDel extends JL_c implements JL {
    public Node typeCheck(TypeChecker tc) throws SemanticException {
        IbexTypeSystem ts = (IbexTypeSystem) tc.typeSystem();
        Context c = tc.context();

        Return n = (Return) node();

        CodeInstance ci = c.currentCode();

        if (ci instanceof Nonterminal) {
            Nonterminal t = (Nonterminal) ci;

            Expr expr = n.expr();

            if (t.symbolType().isVoid()) {
                if (expr != null) {
                    throw new SemanticException("Cannot return a value from " + 
                        t + ".", n.position());
                }
                else {
                    return n;
                }
            }
            else if (expr == null) {
                throw new SemanticException("Must return a value from " +
                    t + ".", n.position());
            }       
                    
            if (ts.isImplicitCastValid(expr.type(), t.symbolType())) {
                return n;
            }
        
            if (ts.numericConversionValid(t.symbolType(),
                                          expr.constantValue())) {
                return n;
            }
            
            throw new SemanticException("Cannot return expression of type " +
                expr.type() + " from " + t + ".", expr.position());
        }

        return super.typeCheck(tc);
    }
}
