package polyglot.ext.ibex.lr;

import polyglot.ext.ibex.types.*;
import polyglot.util.*;
import java.util.*;

class GLRNonterminal extends GLRSymbol {
    Nonterminal nonterm;
    List rules;
    Set first;
    Set follow;
    boolean nullable;

    GLRNonterminal(Nonterminal nonterm, String name, int index) {
        super(name, index);
        this.nonterm = nonterm;
        this.rules = new ArrayList();
        this.first = new HashSet();
        this.follow = new HashSet();
        this.nullable = false;
    }

    List rules() { return rules; }

    Set first() { return first; }
    Set follow() { return follow; }
    boolean isNullable() { return nullable; }
    void setNullable(boolean f) { nullable = f; }

    public boolean equals(Object o) {
        return o instanceof GLRNonterminal && super.equals(o);
    }
}
