package polyglot.ext.ibex.lr;

import java.util.*;
import polyglot.main.Report;
import polyglot.util.InternalCompilerError;

class NFAEdge implements Edge {
    NFAState source;
    NFAState target;
    Label label; /* null if epsilon */

    NFAEdge(NFAState source, NFAState target, Label label) {
        this.source = source;
        this.target = target;
        this.label = label;
    }

    public Node source() { return source; }
    public Node target() { return target; }
    public Label label() { return label; }

    public int hashCode() {
        return target.hashCode() + (label != null ? label.hashCode() : 0);
    }

    public boolean equals(Object o) {
        if (label == null) {
            return o instanceof NFAEdge
                && ((NFAEdge) o).label == null
                && target.equals(((NFAEdge) o).target);
        }
        else {
            return o instanceof NFAEdge
                && label.equals(((NFAEdge) o).label)
                && target.equals(((NFAEdge) o).target);
        }
    }

    public String toString() {
        if (label == null) {
            return source + "--()-->" + target;
        }
        return source + "--(" + label + ")-->" + target;
    }
}
