package polyglot.ext.ibex.lr;

import polyglot.ext.ibex.types.*;
import polyglot.util.*;
import java.util.*;

public class State {
    int index;
    Set items;

    State(int index, Set items) {
        this.index = index;
        this.items = items;
    }

    Set items() { return items; }
    int index() { return index; }

    public boolean equals(Object o) {
        if (o instanceof State) {
            State s = (State) o;
            return index == s.index;
        }
        return false;
    }

    public int hashCode() {
        return index;
    }

    public void dump() {
        System.out.println("State " + index + ":");

        List items = new ArrayList(this.items);
        Collections.sort(items, new Comparator() {
            public int compare(Object o1, Object o2) {
                Item i1 = (Item) o1;
                Item i2 = (Item) o2;
                if (i1.rule.index == i2.rule.index)
                    return i1.dot - i2.dot;
                else
                    return i1.rule.index - i2.rule.index;
            }
        });

        for (Iterator i = items.iterator(); i.hasNext(); ) {
            Item item = (Item) i.next();
            System.out.println("    " + item.toString());
        }
    }

    public String toString() {
        return "State " + index;
    }
}
