package polyglot.ext.j0.ast;

import polyglot.ast.*;
import polyglot.util.*;
import polyglot.ext.j0.parse.Grm;
import polyglot.ext.jl.qq.*;
import polyglot.types.Flags;

import java.util.*;

public class ImplicitImports {

    public ImplicitImports(Grm parser) {
	this.parser = parser;
	this.qq = new QQ(Grm.ext);

	EMPTY = new LinkedList();
	BOOLEAN = qq.parseType("boolean");
	CHAR = qq.parseType("char");
	CHAR_ARRAY = qq.parseType("char []");
	DOUBLE = qq.parseType("double");
	FLOAT = qq.parseType("float");
	INT = qq.parseType("int");
	LONG = qq.parseType("long");
	OBJECT = qq.parseType("Object");
	STRING = qq.parseType("String");

	TypeNode[] a = {BOOLEAN, CHAR, CHAR_ARRAY, DOUBLE, FLOAT, INT, LONG, OBJECT, STRING};
	ALL = a;
    }

    private final Grm parser;
    private final QQ qq;

    private final List EMPTY;
    private final TypeNode BOOLEAN;
    private final TypeNode CHAR;
    private final TypeNode CHAR_ARRAY;
    private final TypeNode DOUBLE;
    private final TypeNode FLOAT;
    private final TypeNode INT;
    private final TypeNode LONG;
    private final TypeNode OBJECT;
    private final TypeNode STRING;
    private final TypeNode[] ALL;

    private static final String IMPORTCLASS = "polyglot.ext.j0.lang.IO";

    private ImportStaticMethod newImport(String name, TypeNode arg) throws Exception {
	Formal f = parser.nf.Formal(Position.COMPILER_GENERATED, Flags.NONE, parser.array(arg, 0), "arg");
	List args = new ArrayList(1);
	args.add(f);
	return parser.nf.ImportStaticMethod(Position.COMPILER_GENERATED, name, args);
    }

    private ImportStaticMethod newImport(String name, List args) {
	return parser.nf.ImportStaticMethod(Position.COMPILER_GENERATED, name, args);
    }

    public List getImplicitImports() throws Exception{
	
	List l = new LinkedList();

	String name = IMPORTCLASS+".print";

	for(int i = 0; i < ALL.length; i++) {
	    l.add(newImport(name, ALL[i]));
	}

	name = IMPORTCLASS+".println";

	for(int i = 0; i < ALL.length; i++) {
	    l.add(newImport(name, ALL[i]));
	}

	l.add(newImport(name, EMPTY));

	l.add(newImport(IMPORTCLASS+".readLine", EMPTY));
	l.add(newImport(IMPORTCLASS+".readChar", EMPTY));
	l.add(newImport(IMPORTCLASS+".readInt", EMPTY));

	return l;
    }

}
