package polyglot.ext.polyj.ast;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;

import java.util.*;

/**
 * Generalization of the Method and Constructor subclasses.
 */
public abstract class ProcedureConstraint_c extends polyglot.ext.jl.ast.Node_c implements ProcedureConstraint {
    protected Flags flags;
    protected String name;
    protected List formals;
    protected List exceptions;
    
    public ProcedureConstraint_c(Position pos) {
        super( pos);
    }
    
    /**
     * Returns the <code>flags</code> modifing this node.
     */
    public Flags flags() 
    {
        return flags;
    }

    /**
     * Returns the name of this this method.
     */
    public String name() 
    {
        return name;
    }

    /**
     * Returns the parameter of this method as position <code>pos</code>.
     */
    public TypeNode getFormalParameterTypeAt(int pos) 
    {
        return (TypeNode)formals.get(pos);
    }

    /**
     * Returns the List of formal parameters.
     */
    public List formals()
    {
        return formals;
    }

    /**
     * Returns the exception at position <code>pos</code> in the exception list.
     */
    public TypeNode getExceptionAt(int pos) 
    {
        return (TypeNode)exceptions.get(pos);
    }

    /**
     * Return the list of exceptions.
     */
    public List exceptions() 
    {
        return exceptions;
    }
}
