package polyglot.ext.polyj.parse;

import polyglot.ext.polyj.ast.*;

import polyglot.ast.*;
import polyglot.visit.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.parse.*;

import java.util.*;

/**
 * An ExprSub is a Sub whose syntax makes it unambiguously an expression
 * (any expression that isn't just a Wrapped Parse).
 */
public class ExprSub extends AbstractSub {
    Expr e;
    
    public ExprSub(BaseParser parser, Position pos, Expr e) {
        super(parser, pos);
        this.e = e;
    }
    
    public Expr toExpr() {
        return e;
    }
    
    public Parse prepend(Parse base) throws Exception {
        return new Access(parser, base.pos, base, e);    
    }
    
    public ParamNode toParam() throws Exception {
        return nf.ExprParam(pos, e);    
    }
}
