package polyglot.ext.polyj.types;

import polyglot.types.*;
import polyglot.util.*;
import java.util.*;

/**
 * A <code>PolyJArrayType_c</code> must implement translation
 * differently than <code>ArrayType_c</code> because the innermost
 * dimension of an array with a parametric base type is represented
 * as <code>Object</code> in the translation.
 */
public class PolyJArrayType_c extends polyglot.ext.jl.types.ArrayType_c 
	implements PolyJArrayType
{
    public PolyJArrayType_c(TypeSystem ts, Position pos, Type base) {
	super(ts, pos, base);
    }

    /** Translate the type. */
    public String translate(Resolver c) {
	if (base() instanceof ParamType) {
	    return typeSystem().Object().translate(c);
	} else {
            return base().translate(c) + "[]"; 
	}
    }
}
