package polyglot.ext.pragma.ast;

import polyglot.ast.*;
import polyglot.visit.*;
import polyglot.util.*;
import polyglot.ext.jl.ast.Stmt_c;
import polyglot.ext.pragma.ast.PragmaNode;

/**
 * A <code>Stmt</code> represents any Java statement.  All statements must
 * be subtypes of Statement.
 */
public class PragmaNode_c extends Stmt_c implements PragmaNode
{
    String pragma;

    public PragmaNode_c(Del ext, Position pos, String pragma) {
        super(ext,pos);
        this.pragma = pragma;
    }
    
    public String pragmaStr() { return pragma; }

    public void prettyPrint(CodeWriter w, PrettyPrinter pp) {
        w.write("#pragma");
        w.write(pragma);
        w.newline();
    }

    public void translate(CodeWriter w, Translator tr) {
        w.write(pragma);
        w.newline();
    }
}
